Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -2616,18 +8608,18 @@
             clearrequestfields(state);
             state.xupdated = true;
-            state.rstate.stage = 3;
+            state.rstate.stage = 13;
             goto lbl_rcomm;
-        lbl_3:
+        lbl_13:
             state.xupdated = false;
-        lbl_10:
+        lbl_30:
             state.repnfev = state.repnfev+state.nfev;
             state.repiterationscount = state.repiterationscount+1;
             for(i_=0; i_<=n-1;i_++)
             {
-                state.s[state.p,i_] = state.s[state.p,i_] + state.x[i_];
+                state.sk[state.p,i_] = state.sk[state.p,i_] + state.x[i_];
             }
             for(i_=0; i_<=n-1;i_++)
             {
-                state.y[state.p,i_] = state.y[state.p,i_] + state.g[i_];
+                state.yk[state.p,i_] = state.yk[state.p,i_] + state.g[i_];
             }
             
@@ -2635,5 +8627,5 @@
             // Stopping conditions
             //
-            if( state.repiterationscount>=maxits & maxits>0 )
+            if( state.repiterationscount>=state.maxits & state.maxits>0 )
             {
                 
@@ -2645,10 +8637,10 @@
                 return result;
             }
-            v = 0.0;
-            for(i_=0; i_<=n-1;i_++)
-            {
-                v += state.g[i_]*state.g[i_];
-            }
-            if( (double)(Math.Sqrt(v))<=(double)(epsg) )
+            v = 0;
+            for(i=0; i<=n-1; i++)
+            {
+                v = v+math.sqr(state.g[i]*state.s[i]);
+            }
+            if( (double)(Math.Sqrt(v))<=(double)(state.epsg) )
             {
                 
@@ -2660,5 +8652,5 @@
                 return result;
             }
-            if( (double)(state.fold-state.f)<=(double)(epsf*Math.Max(Math.Abs(state.fold), Math.Max(Math.Abs(state.f), 1.0))) )
+            if( (double)(state.fold-state.f)<=(double)(state.epsf*Math.Max(Math.Abs(state.fold), Math.Max(Math.Abs(state.f), 1.0))) )
             {
                 
@@ -2670,10 +8662,10 @@
                 return result;
             }
-            v = 0.0;
-            for(i_=0; i_<=n-1;i_++)
-            {
-                v += state.s[state.p,i_]*state.s[state.p,i_];
-            }
-            if( (double)(Math.Sqrt(v))<=(double)(epsx) )
+            v = 0;
+            for(i=0; i<=n-1; i++)
+            {
+                v = v+math.sqr(state.sk[state.p,i]/state.s[i]);
+            }
+            if( (double)(Math.Sqrt(v))<=(double)(state.epsx) )
             {
                 
@@ -2718,10 +8710,10 @@
                 for(i_=0; i_<=n-1;i_++)
                 {
-                    v += state.y[state.p,i_]*state.s[state.p,i_];
+                    v += state.yk[state.p,i_]*state.sk[state.p,i_];
                 }
                 vv = 0.0;
                 for(i_=0; i_<=n-1;i_++)
                 {
-                    vv += state.y[state.p,i_]*state.y[state.p,i_];
+                    vv += state.yk[state.p,i_]*state.yk[state.p,i_];
                 }
                 if( (double)(v)==(double)(0) | (double)(vv)==(double)(0) )
@@ -2762,5 +8754,5 @@
                     for(i_=0; i_<=n-1;i_++)
                     {
-                        v += state.s[ic,i_]*state.work[i_];
+                        v += state.sk[ic,i_]*state.work[i_];
                     }
                     state.theta[ic] = v;
@@ -2768,5 +8760,5 @@
                     for(i_=0; i_<=n-1;i_++)
                     {
-                        state.work[i_] = state.work[i_] - vv*state.y[ic,i_];
+                        state.work[i_] = state.work[i_] - vv*state.yk[ic,i_];
                     }
                 }
@@ -2791,4 +8783,26 @@
                     fbls.fblscholeskysolve(state.denseh, 1, n, true, ref state.work, ref state.autobuf);
                 }
+                if( state.prectype==2 )
+                {
+                    
+                    //
+                    // diagonal approximation is used
+                    //
+                    for(i=0; i<=n-1; i++)
+                    {
+                        state.work[i] = state.work[i]/state.diagh[i];
+                    }
+                }
+                if( state.prectype==3 )
+                {
+                    
+                    //
+                    // scale-based preconditioner is used
+                    //
+                    for(i=0; i<=n-1; i++)
+                    {
+                        state.work[i] = state.work[i]*state.s[i]*state.s[i];
+                    }
+                }
                 for(i=state.k-state.q; i<=state.k; i++)
                 {
@@ -2797,10 +8811,10 @@
                     for(i_=0; i_<=n-1;i_++)
                     {
-                        v += state.y[ic,i_]*state.work[i_];
+                        v += state.yk[ic,i_]*state.work[i_];
                     }
                     vv = state.rho[ic]*(-v+state.theta[ic]);
                     for(i_=0; i_<=n-1;i_++)
                     {
-                        state.work[i_] = state.work[i_] + vv*state.s[ic,i_];
+                        state.work[i_] = state.work[i_] + vv*state.sk[ic,i_];
                     }
                 }
@@ -2816,6 +8830,6 @@
                 state.k = state.k+1;
             }
-            goto lbl_6;
-        lbl_7:
+            goto lbl_21;
+        lbl_22:
             result = false;
             return result;
@@ -2828,14 +8842,10 @@
             state.rstate.ia[0] = n;
             state.rstate.ia[1] = m;
-            state.rstate.ia[2] = maxits;
-            state.rstate.ia[3] = i;
-            state.rstate.ia[4] = j;
-            state.rstate.ia[5] = ic;
-            state.rstate.ia[6] = mcinfo;
-            state.rstate.ra[0] = epsf;
-            state.rstate.ra[1] = epsg;
-            state.rstate.ra[2] = epsx;
-            state.rstate.ra[3] = v;
-            state.rstate.ra[4] = vv;
+            state.rstate.ia[2] = i;
+            state.rstate.ia[3] = j;
+            state.rstate.ia[4] = ic;
+            state.rstate.ia[5] = mcinfo;
+            state.rstate.ra[0] = v;
+            state.rstate.ra[1] = vv;
             return result;
         }
@@ -2934,6 +8944,6 @@
                 state.x[i_] = x[i_];
             }
-            state.rstate.ia = new int[6+1];
-            state.rstate.ra = new double[4+1];
+            state.rstate.ia = new int[5+1];
+            state.rstate.ra = new double[1+1];
             state.rstate.stage = -1;
             clearrequestfields(state);
